package no.rwr.x;

/** Common base class for all resources that are stored on the server
   and refered to on the client side using XIDs. */
public class XID {

    public XID(Display display, int xid) {
	this.display = display;
	this.xid = xid;
    };

    public final int getXID() {
	return xid;
    }

    public final Display getDisplay() {
	return display;
    }

    protected Display display;
    protected int xid;

    protected String params() {
	return "display=" + display + ",xid=" + xid;
    }

    public String toString() {
	return getClass().getName() +
	    "[" + params() + "]";
    }

}
