#include <X11/Xlib.h>

#include <X11/Xlib.h>

#include <cni.h>
#include <gnu/gcj/RawData.h>

#include "no/rwr/x/Display.h"
#include "no/rwr/x/Window.h"
#include "no/rwr/x/XEvent.h"
#include "no/rwr/x/XExposeEvent.h"

void no::rwr::x::XEvent::init() {
    ::XEvent* event = new ::XEvent;
    structure = reinterpret_cast<gnu::gcj::RawData*>(event);
}

void no::rwr::x::XEvent::finalize() {
    delete structure;
    structure = 0;
}

void no::rwr::x::XEvent::loadNext() {
    ::Display* dpy = (::Display*) display->display;
    ::XEvent* evt = (::XEvent*) structure;
    XNextEvent(dpy, evt);
    // What does XNextEvent return?
}

jint no::rwr::x::XEvent::getType() {
    ::XEvent* event = (::XEvent*) structure;
    return event->type;
}

no::rwr::x::Window* no::rwr::x::XEvent::getWindow() {
    ::XEvent* event = (::XEvent*) structure;
    return display->getWindow(event->xany.window);
}

